# easybuild

EasyBuild is a software build and installation framework that allows you to manage software in an efficient way: (http://easybuild.readthedocs.io/en/latest/Introduction.html). This repo provides additional easyconfigs for ELIC ecosystem

## Install

Go to `/opt/easybuild` and:

```bash
rmdir easyconfigs; git clone ssh://egit/pbarriat/easyconfigs.git
```

## Requirements

* openSUSE : `gcc-c++ patch libopenssl-devel gperf`

## Getting started

Check if you have the lastest easybuild version:

```bash
sudo pip install easybuild --upgrade
```

Then call `screen` and :
* `eb iccifort-2018.0.128-GCC-6.4.0-2.28.eb -r`
* `eb NCL-6.4.0-intel-2018.eb -r`
* `eb CDO-1.8.1-intel-2018.eb -r`
* `eb ncview-2.1.7-intel-2018.eb -r`
* `eb NCO-4.6.6-intel-2018.eb -r`
* `eb R-3.4.1-intel-2018.eb -r`
* `eb GDAL-2.2.0-intel-2018-Python-3.6.1.eb -r`
* `eb MATLAB-UCL-2017a.eb`
* `eb Python-3.6.2-foss-2017b.eb -r`

Finally, run `./utils/install_modulerc.sh`

## Python2 packages

Fix `/opt/modules/all/GEOS/3.6.1-intel-2018.lua` by adding `setenv("GEOS_DIR", root)`

```bash
module load NCL PROJ ; pip install geos netcdf4 cdo geoval cartopy iris matplotlib ipython pyproj scikit-image pillow pandas xarray joblib six gdal shapely rasterio geopandas pytest boto3 salem motionless progressbar2 fiona geopandas configobj https://github.com/matplotlib/basemap/archive/v1.1.0.tar.gz; module purge
```

## Python3 issue

Check if you have an issue with Python3:

```bash
module load Python/3.6.1-intel-2018
pip
```

If yes: 

```bash
pip install -Iv pysha3==0.3
pip
vimdiff /opt/software/Python/3.6.1-intel-2018/lib/python3.6/hashlib.py utils/hashlib.py
```

## Python3 packages

Fix `/opt/modules/all/GEOS/3.6.1-intel-2018-Python-3.6.1.lua` by adding `setenv("GEOS_DIR", root)`

```bash
module load GDAL/2.2.0-intel-2018-Python-3.6.1 PROJ; pip install geos netcdf4 cdo geoval cartopy matplotlib ipython pyproj scikit-image pillow pandas xarray joblib six gdal shapely rasterio geopandas pytest boto3 salem motionless progressbar2 fiona geopandas configobj https://github.com/matplotlib/basemap/archive/v1.1.0.tar.gz; module purge
```

## MATLAB 2013a

```bash
rsync -av 10.90.90.50:/opt/software/MATLAB/2013a /opt/software/MATLAB
scp 10.90.90.50:/opt/modules/all/MATLAB/2013a.lua /opt/modules/all/MATLAB
```

